VERSION 5.00
Begin VB.UserControl DynFrame 
   ClientHeight    =   2280
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5580
   ControlContainer=   -1  'True
   ScaleHeight     =   152
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   372
   ToolboxBitmap   =   "DynFrame.ctx":0000
   Begin VB.PictureBox picHeadline 
      BorderStyle     =   0  'Kein
      Height          =   240
      Left            =   0
      ScaleHeight     =   16
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   326
      TabIndex        =   0
      Top             =   0
      Width           =   4890
      Begin VB.Image imgCross 
         Height          =   135
         Left            =   4500
         Picture         =   "DynFrame.ctx":0312
         Top             =   45
         Width           =   135
      End
      Begin VB.Label lblHeadline 
         BackStyle       =   0  'Transparent
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FFFFFF&
         Height          =   195
         Left            =   375
         TabIndex        =   1
         Top             =   15
         Width           =   1740
      End
      Begin VB.Image imgArr 
         Height          =   75
         Left            =   75
         Picture         =   "DynFrame.ctx":036E
         Top             =   75
         Width           =   135
      End
      Begin VB.Shape shpHeadline 
         BackColor       =   &H00000000&
         BorderColor     =   &H00000000&
         BorderStyle     =   0  'Transparent
         FillColor       =   &H00808080&
         FillStyle       =   0  'Ausgefllt
         Height          =   240
         Left            =   0
         Shape           =   4  'Gerundetes Rechteck
         Top             =   0
         Width           =   4740
      End
   End
   Begin VB.Timer tmrMouseOut 
      Enabled         =   0   'False
      Interval        =   5
      Left            =   3375
      Top             =   1125
   End
   Begin VB.Image cross2 
      Height          =   135
      Left            =   2925
      Picture         =   "DynFrame.ctx":03BF
      Top             =   1050
      Visible         =   0   'False
      Width           =   135
   End
   Begin VB.Image cross1 
      Height          =   135
      Left            =   2625
      Picture         =   "DynFrame.ctx":041B
      Top             =   1050
      Visible         =   0   'False
      Width           =   135
   End
   Begin VB.Image Arrow1 
      Height          =   135
      Index           =   0
      Left            =   1350
      Picture         =   "DynFrame.ctx":0477
      Top             =   1350
      Visible         =   0   'False
      Width           =   75
   End
   Begin VB.Line LineDown 
      BorderColor     =   &H00808080&
      BorderStyle     =   6  'Innen ausgefllt
      Index           =   1
      X1              =   0
      X2              =   370.933
      Y1              =   150
      Y2              =   150
   End
   Begin VB.Image Arrow2 
      Height          =   135
      Index           =   0
      Left            =   1350
      Picture         =   "DynFrame.ctx":04CB
      Top             =   1200
      Visible         =   0   'False
      Width           =   75
   End
   Begin VB.Image Arrow1 
      Height          =   75
      Index           =   1
      Left            =   900
      Picture         =   "DynFrame.ctx":051F
      Top             =   1200
      Visible         =   0   'False
      Width           =   135
   End
   Begin VB.Image Arrow2 
      Height          =   75
      Index           =   1
      Left            =   900
      Picture         =   "DynFrame.ctx":0570
      Top             =   1350
      Visible         =   0   'False
      Width           =   135
   End
   Begin VB.Line LineDown 
      BorderColor     =   &H00FFFFFF&
      BorderWidth     =   2
      Index           =   0
      X1              =   1
      X2              =   370.933
      Y1              =   151
      Y2              =   151
   End
End
Attribute VB_Name = "DynFrame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'##### Dynamisches Frame (Werkzeugfenster) #####

Option Explicit

Dim i_Open As Boolean
Dim NormalHeight As Integer
Dim Left As Long, Top As Long
Dim MouseOver As Byte '0: Headline; 1: Kreuz;

Event Change()  'Status gendert
Event Closed()  'Geschlossen (Kreuzchen)

Const Font_M = &HE0E0E0
'..

Public Property Let Caption(wert As String)
lblHeadline.Caption = wert
End Property

Public Property Get Caption() As String
Caption = lblHeadline.Caption
End Property

Public Property Let Opened(wert As Boolean)
i_Open = wert
SetOpened
RaiseEvent Change
End Property

Public Property Get Opened() As Boolean
Opened = i_Open
End Property

Public Property Let CloseVisible(wert As Boolean)
imgCross.Visible = wert
End Property

Public Property Get CloseVisible() As Boolean
CloseVisible = imgCross.Visible
End Property

Private Sub imgArr_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
picHeadline_MouseDown Button, Shift, imgArr.Left + X / 15, imgArr.Top + Y / 15
End Sub

Private Sub imgArr_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
picHeadline_MouseMove Button, Shift, imgArr.Left + X / 15, imgArr.Top + Y / 15
End Sub

Private Sub imgCross_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
RaiseEvent Closed
End Sub

Private Sub imgCross_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
If tmrMouseOut.Enabled = False Or MouseOver = 0 Then
    tmrMouseOut.Enabled = True
    lblHeadline.ForeColor = vbWhite
    imgArr.Picture = Arrow1(-i_Open).Picture
    
    imgCross.Picture = cross2.Picture
    MouseOver = 1
End If
End Sub

Private Sub lblHeadline_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
picHeadline_MouseDown Button, Shift, lblHeadline.Left + X / 15, lblHeadline.Top + Y / 15
End Sub

Private Sub lblHeadline_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
picHeadline_MouseMove Button, Shift, lblHeadline.Left + X / 15, lblHeadline.Top + Y / 15
End Sub

Private Sub picHeadline_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
i_Open = Not i_Open
SetOpened 1
RaiseEvent Change
End Sub

Private Sub picHeadline_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
If X > 0 And Y > 0 And X < picHeadline.ScaleWidth And Y < picHeadline.ScaleHeight Then
    If tmrMouseOut.Enabled = False Or MouseOver = 1 Then
        Call GetCursorPos(CursorPos)
        Top = CursorPos.Y - Y
        Left = CursorPos.X - X
        tmrMouseOut.Enabled = True
        lblHeadline.ForeColor = Font_M
        imgArr.Picture = Arrow2(-i_Open).Picture
        imgCross.Picture = cross1.Picture
        MouseOver = 0
    End If
End If
End Sub

Private Sub tmrMouseOut_Timer()
Call GetCursorPos(CursorPos)
If Not (CursorPos.Y > Top And CursorPos.X > Left And CursorPos.Y < Top + picHeadline.ScaleHeight And CursorPos.X < Left + picHeadline.ScaleWidth) Then
    If MouseOver = 0 Then
        lblHeadline.ForeColor = vbWhite
        imgArr.Picture = Arrow1(-i_Open).Picture
    Else
        imgCross.Picture = cross1.Picture
    End If
    tmrMouseOut.Enabled = False
End If
End Sub

Private Sub UserControl_Initialize()
NormalHeight = UserControl.ScaleHeight
i_Open = True
End Sub

Private Sub UserControl_Resize()
shpHeadline.Width = UserControl.ScaleWidth
picHeadline.Width = UserControl.ScaleWidth
lblHeadline.Width = UserControl.ScaleWidth - lblHeadline.Left - 5
imgCross.Left = UserControl.ScaleWidth - imgCross.Width - 5
LineDown(0).Y1 = UserControl.ScaleHeight - 1
LineDown(0).Y2 = UserControl.ScaleHeight - 1
LineDown(1).Y1 = UserControl.ScaleHeight - 2
LineDown(1).Y2 = UserControl.ScaleHeight - 2
LineDown(0).X2 = UserControl.ScaleWidth - 1
LineDown(1).X2 = UserControl.ScaleWidth - 1
If UserControl.ScaleHeight > picHeadline.Height Then NormalHeight = UserControl.ScaleHeight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
On Error Resume Next
lblHeadline.Caption = PropBag.ReadProperty("Caption")
i_Open = PropBag.ReadProperty("Opened", True)
NormalHeight = PropBag.ReadProperty("NormalHeight", UserControl.ScaleHeight)
imgCross.Visible = PropBag.ReadProperty("CloseVisible", True)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
PropBag.WriteProperty "Caption", lblHeadline.Caption
PropBag.WriteProperty "Opened", i_Open
PropBag.WriteProperty "NormalHeight", NormalHeight
PropBag.WriteProperty "CloseVisible", imgCross.Visible
End Sub

Private Sub SetOpened(Optional MouseOver As Byte)
If Opened = True Then
    If NormalHeight > picHeadline.Height Then UserControl.Height = NormalHeight * 15
    imgArr.Left = 5
    imgArr.Top = 5
    If MouseOver = 1 Then
        imgArr.Picture = Arrow2(1).Picture
    Else
        imgArr.Picture = Arrow1(1).Picture
    End If
Else
    If UserControl.ScaleHeight > picHeadline.Height Then NormalHeight = UserControl.ScaleHeight
    UserControl.Height = picHeadline.Height * 15
    imgArr.Left = 7
    imgArr.Top = 3
    If MouseOver = 1 Then
        imgArr.Picture = Arrow2(0).Picture
    Else
        imgArr.Picture = Arrow1(0).Picture
    End If
End If
End Sub
