VERSION 5.00
Begin VB.UserControl Gauge 
   ClientHeight    =   3015
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3990
   Picture         =   "Gauge.ctx":0000
   ScaleHeight     =   201
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   266
   ToolboxBitmap   =   "Gauge.ctx":0102
   Begin VB.Line LinePoint 
      BorderColor     =   &H000000FF&
      X1              =   5
      X2              =   15
      Y1              =   10
      Y2              =   10
   End
   Begin VB.Label lblEinheit 
      Alignment       =   2  'Zentriert
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "a"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   6
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   150
      Left            =   210
      TabIndex        =   0
      Top             =   300
      Width           =   60
   End
End
Attribute VB_Name = "Gauge"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)


Private Const CenterX = 15.5
Private Const CenterY = 17
Private Const Radius = 12

Dim n As Integer

Dim MaxVal As Single
Dim aktVal As Single
Dim aktWinkelB As Single

Dim iUnit As Integer

Dim Einheit As String
Dim iCellNr As Integer

Public Property Get CellNr() As Integer
CellNr = iCellNr
End Property

Public Sub SetCell(Nr As Integer)
If aZelle(Nr).ID = 2 Then   'Voltmeter
    iUnit = vbSpannung
Else                        'Amperemeter
    iUnit = vbStromstrke
End If
Einheit = GetEinheitByUnit(iUnit)
iCellNr = Nr
SetMaxVal
Update
End Sub

'Maximalwert setzten
Private Sub SetMaxVal()
MaxVal = GetValDbl(iCellNr, vbZelle, iUnit, vbSchein)
If MaxVal > 0 Then
    'Exponent bestimmten
    n = 1
    If MaxVal > 10 Then
        Do While MaxVal > 10
            MaxVal = MaxVal / 10
            n = n + 1
        Loop
    ElseIf MaxVal <= 1 Then
        Do While MaxVal <= 1
            MaxVal = MaxVal * 10
            n = n - 1
        Loop
    End If
    MaxVal = 10 ^ n
Else
    MaxVal = 1
End If
lblEinheit.Caption = FormatData(MaxVal, Einheit, , 2, , 3)
End Sub

'Einlesen der Daten
Public Sub Update()
aktVal = GetValDbl(iCellNr, vbZelle, iUnit, vbSchein)
If aktVal > MaxVal Then SetMaxVal
aktWinkelB = Pi - 0.1 - ((Pi - 0.2) / MaxVal) * aktVal

'uerer Punkt
LinePoint.X1 = Cos(aktWinkelB) * Radius + CenterX
LinePoint.Y1 = 31 - Sin(aktWinkelB) * Radius - CenterY
'Innerer Punkt
LinePoint.X2 = Cos(aktWinkelB) * 2 + CenterX
LinePoint.Y2 = 31 - Sin(aktWinkelB) - CenterY
End Sub

Private Sub UserControl_Initialize()
UserControl.BackColor = Farbe_N
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub UserControl_Resize()
UserControl.Height = 32 * 15
UserControl.Width = 32 * 15
End Sub

Public Sub Mark()
UserControl.BackColor = Farbe_M
End Sub

Public Sub DeMark()
UserControl.BackColor = Farbe_N
End Sub
