VERSION 5.00
Begin VB.Form frmSimWin 
   BorderStyle     =   4  'Festes Werkzeugfenster
   Caption         =   "Simulationsfenster"
   ClientHeight    =   6360
   ClientLeft      =   150
   ClientTop       =   390
   ClientWidth     =   2760
   Icon            =   "frmSimWin.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   424
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   184
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin eXact.DynFrame SimFrame 
      Height          =   1440
      Left            =   75
      TabIndex        =   6
      Top             =   4875
      Width           =   2640
      _ExtentX        =   4657
      _ExtentY        =   2540
      Caption         =   "Simulation"
      Opened          =   -1  'True
      NormalHeight    =   96
      CloseVisible    =   0   'False
      Begin VB.CommandButton cmdEzsStart 
         Caption         =   "&Echtzeitsimulation starten"
         Height          =   315
         Left            =   0
         TabIndex        =   7
         Top             =   600
         Width           =   2565
      End
      Begin VB.CommandButton cmdNormStart 
         Caption         =   "&Normal starten"
         Height          =   315
         Left            =   0
         TabIndex        =   8
         Top             =   300
         Width           =   2565
      End
      Begin VB.Shape shpEZS 
         BackColor       =   &H0000FF00&
         BackStyle       =   1  'Undurchsichtig
         Height          =   165
         Left            =   2025
         Shape           =   3  'Kreis
         Top             =   975
         Visible         =   0   'False
         Width           =   165
      End
      Begin VB.Label lblEZS 
         Caption         =   "Echtzeitsimulation inaktiv"
         Height          =   240
         Left            =   75
         TabIndex        =   10
         Top             =   975
         Width           =   1965
      End
      Begin VB.Label lblRes 
         ForeColor       =   &H00000000&
         Height          =   210
         Left            =   75
         TabIndex        =   9
         Top             =   1200
         Width           =   2190
      End
   End
   Begin VB.CheckBox chkHold 
      Caption         =   "Zelle halten"
      Height          =   195
      Left            =   1425
      TabIndex        =   0
      Top             =   45
      Width           =   1140
   End
   Begin eXact.DynFrameSim DataFrame 
      Height          =   1410
      Index           =   2
      Left            =   75
      TabIndex        =   4
      Top             =   3375
      Width           =   2640
      _ExtentX        =   4657
      _ExtentY        =   2487
      Caption         =   "Zelle"
      Opened          =   -1  'True
      ControlsVisible =   -1  'True
   End
   Begin eXact.DynFrameSim DataFrame 
      Height          =   1410
      Index           =   1
      Left            =   75
      TabIndex        =   5
      Top             =   1875
      Width           =   2640
      _ExtentX        =   4657
      _ExtentY        =   2487
      Caption         =   "Zweig"
      Opened          =   -1  'True
      ControlsVisible =   -1  'True
   End
   Begin eXact.DynFrameSim DataFrame 
      Height          =   1410
      Index           =   0
      Left            =   75
      TabIndex        =   3
      Top             =   300
      Width           =   2640
      _ExtentX        =   4657
      _ExtentY        =   2487
      Caption         =   "Instanz"
      Opened          =   -1  'True
      ControlsVisible =   -1  'True
   End
   Begin VB.Label lblZelle 
      Caption         =   "0"
      Height          =   240
      Left            =   600
      TabIndex        =   2
      Top             =   45
      Width           =   540
   End
   Begin VB.Label Label4 
      Caption         =   "Zelle: "
      Height          =   240
      Left            =   75
      TabIndex        =   1
      Top             =   45
      Width           =   465
   End
End
Attribute VB_Name = "frmSimWin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public aktZelle As Integer
Const c_DataFrame = 4       'Anzahl Toolwins (exakt, da ab 1)
'..

Private Sub chkHold_Click()
If chkHold.Value = 1 Then
   HoldSimWin = 1
Else
   HoldSimWin = 0
   frmHaupt.UpdateSimWin
End If
End Sub

Private Sub cmdEzsStart_Click()
frmHaupt.setEZS
End Sub

Private Sub cmdNormStart_Click()
Analyse
End Sub

Private Sub DataFrame_Change(Index As Integer)
OrderToolboxes
End Sub

Private Sub DataFrame_Resize(Index As Integer)
OrderToolboxes
End Sub

Private Sub Form_Load()
On Error Resume Next
SimWin = 1
HoldSimWin = 0
frmHaupt.UpdateSimWin
UpdateData
OrderToolboxes
If frmDemoExplain.Visible = True Then Exit Sub
Me.Left = GetSettingIni(SettingsFile, "sim_window", "left")
If Me.Left > Screen.Width - (20 * 15) Then Me.Left = Screen.Width / 2 - Me.Width / 2
Me.Top = GetSettingIni(SettingsFile, "sim_window", "top")
If Me.Top > Screen.Height - (20 * 15) Then Me.Top = Screen.Height / 2 - Me.Height / 2
End Sub

Private Sub Form_Unload(Cancel As Integer)
SaveSettingIni SettingsFile, "sim_window", "left", Me.Left
SaveSettingIni SettingsFile, "sim_window", "top", Me.Top
SimWin = 0
HoldSimWin = 0
End Sub

Public Sub UpdateData()
If EZS = 1 Then
    cmdEzsStart.Caption = "Echtzeitsimulation beenden"
    lblEZS.Caption = "Echtzeitsimulation aktiv"
    shpEZS.Visible = True
Else
    cmdEzsStart.Caption = "Echtzeitsimulation starten"
    lblEZS.Caption = "Echtzeitsimulation inaktiv"
    shpEZS.Visible = False
End If
lblRes.ForeColor = frmHaupt.lblRes.ForeColor
lblRes.Caption = frmHaupt.lblRes.Caption
End Sub

'Neuordnen der Werkzeugfenster
Private Sub OrderToolboxes()
Dim c1 As Integer, c2 As Integer  'Zhlervariablen, da hier m und n nicht verwendet werden drfen
c2 = -1
'Ausrichten
DataFrame(0).Top = lblZelle.Top + lblZelle.Height
For c1 = 1 To 2
    DataFrame(c1).Top = DataFrame(c1 - 1).Top + DataFrame(c1 - 1).Height + 2 + 1 * (-DataFrame(c1 - 1).Opened)
Next
c1 = 3
SimFrame.Top = DataFrame(c1 - 1).Top + DataFrame(c1 - 1).Height + 2 + 1 * (-DataFrame(c1 - 1).Opened)
frmSimWin.Height = (SimFrame.Top + SimFrame.Height + 2 + 1 * (-SimFrame.Opened) + 22) * 15
End Sub

